// AiLongDlg.cpp : source code for LF STD radio observation
//

#include "stdafx.h"
#include "AiLong.h"
#include "AiLongDlg.h"
//C lib
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
//C++ lib
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
//AIO lib
#include "caio.h"
//FFTW3 lib
#include "fftw3.h"
#pragma comment(lib, "libfftw3-3.lib")
#pragma comment(lib, "libfftw3f-3.lib")
#pragma comment(lib, "libfftw3l-3.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CAiLongDlg

CAiLongDlg::CAiLongDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAiLongDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAiLongDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAiLongDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAiLongDlg)
	DDX_Control(pDX, IDC_TOTAL, m_Total);
	DDX_Control(pDX, IDC_EVENT, m_Event);
	DDX_Control(pDX, IDC_STATUS, m_Status);
	DDX_Control(pDX, IDC_COUNT, m_Count);
	DDX_Control(pDX, IDC_ERRORSTRING, m_ErrorString);
	DDX_Control(pDX, IDC_COMBO_RANGE, m_AiRange);
	DDX_Control(pDX, IDC_EDIT_DEVICE, m_Device);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COMBO_FFT, m_FFT_WND);
	DDX_Control(pDX, IDC_EDIT_FFT_Num, m_FFT_Num);

	// Define Controls
	int nIDC,i;
	nIDC = IDC_EDIT_FQ1;
	for (i=0; i < 10; i++) {
		DDX_Control(pDX, nIDC+i*3, m_Edit_fq[i]);
		DDX_Control(pDX, nIDC+i*3+1, m_Edit_pw[i]);
		DDX_Control(pDX, nIDC+i*3+2, m_Edit_ph[i]);
	}
	nIDC = IDC_EDIT_FQ11;
	for (i=10; i < 16; i++) {
		DDX_Control(pDX, nIDC+(i-10)*3, m_Edit_fq[i]);
		DDX_Control(pDX, nIDC+(i-10)*3+1, m_Edit_pw[i]);
		DDX_Control(pDX, nIDC+(i-10)*3+2, m_Edit_ph[i]);
	}
	nIDC = IDC_EDIT_FQ17;
	for (i=16; i < 20; i++) {
		DDX_Control(pDX, nIDC+(i-16)*3, m_Edit_fq[i]);
		DDX_Control(pDX, nIDC+(i-16)*3+1, m_Edit_pw[i]);
		DDX_Control(pDX, nIDC+(i-16)*3+2, m_Edit_ph[i]);
	}

	DDX_Control(pDX, IDC_PICT_QL, m_PICT_QL);
	DDX_Control(pDX, IDC_PICT_SP, m_PICT_SP);
	DDX_Control(pDX, IDC_PICT_LM, m_IDC_PICT_LM);
	DDX_Control(pDX, IDC_COMBO_Sel, m_Freq_List);
	DDX_Control(pDX, IDC_EDIT_SF, m_EDIT_SF);
	DDX_Control(pDX, IDC_EDIT_EF, m_EDIT_EF);
	DDX_Control(pDX, IDC_EDIT_STA, m_STA);
	DDX_Control(pDX, IDC_EDIT_X1, m_EDIT_X1);
	DDX_Control(pDX, IDC_EDIT_X2, m_EDIT_X2);
	DDX_Control(pDX, IDC_EDIT_SFM, m_EDIT_SFM);
	DDX_Control(pDX, IDC_WDT, m_wdt);
	DDX_Control(pDX, IDC_COMBO_CH, m_ch);
	DDX_Control(pDX, IDC_COMBO_DISP, m_ch_disp);
}

BEGIN_MESSAGE_MAP(CAiLongDlg, CDialog)
	//{{AFX_MSG_MAP(CAiLongDlg)
	ON_WM_PAINT()
	ON_WM_TIMER()			// 2016-08-03
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_INIT, OnButtonInit)
	ON_CBN_SELCHANGE(IDC_COMBO_RANGE, OnSelchangeComboRange)
	ON_BN_CLICKED(IDC_BUTTON_END, OnButtonEnd)
	ON_BN_CLICKED(IDC_BUTTON_SET, OnButtonSet)
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_STATUS, OnButtonStatus)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAiLongDlg bZ[W nh

BOOL CAiLongDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);	
	SetIcon(m_hIcon, FALSE);
	
	unsigned char uc_val;

	//Devie name + Staion name
	Read_Dev();

	//Set number of point for FFT (fixed to 4000)
	m_FFT_Num.SetWindowText("4000");

	//Set ADC Input voltage range
	m_AiRange.AddString("-10 - +10V");
	m_AiRange.AddString("-5 - +5V");
	m_AiRange.SetCurSel(0);	// default is +/- 10V  !!! DO NOT CHANGE !!!

	//Set FFT window function
	m_FFT_WND.AddString("Blackman");
	m_FFT_WND.AddString("Hamming");
	m_FFT_WND.AddString("Hanning");
	m_FFT_WND.AddString("Flat");
	m_FFT_WND.SetCurSel(0); // default is Blackman
	uc_val = (unsigned char)m_FFT_WND.GetCurSel();
	if (uc_val == 0){
		pow_ref = (float)-52.5;
	}else if (uc_val == 1){
		pow_ref = (float)-54.7;
	}else if (uc_val == 2){
		pow_ref = (float)-54.0;
	}else if (uc_val == 3){
		pow_ref = (float)-60.0;
	}

	//Set Number of input signal ch.
	m_ch.AddString("1");
	m_ch.AddString("2");
	m_ch.SetCurSel(0);	// default is 1

	//Set channel number displayed on QL
	m_ch_disp.AddString("1");
	m_ch_disp.AddString("2");
	m_ch_disp.SetCurSel(0);	// default is 1

	//Set default frequency range for QL
	m_EDIT_X1.SetWindowText("0.0");
	m_EDIT_X2.SetWindowText("100.0");

	//Initialize
	OnButtonInit();

	//Enable WDT
	n_wdt = m_n_wdt;
	n_wdt_hist = 0;
	m_n_wdt = SetTimer(1, 1000, NULL);

	return TRUE;  // TRUE
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CAiLongDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CAiLongDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//--------------------------------------------------------------------------------------------------
//	foCX̏																				
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::OnButtonInit() 
{
	Prog_Init();
	Prog_Range();
	Prog_Set();
	Prog_Start();
}

//--------------------------------------------------------------------------------------------------
//	AiO̓W̐ݒ																		
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::OnSelchangeComboRange() 
{
	Prog_Range();
}

//--------------------------------------------------------------------------------------------------
//	ϊݒ																					
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::OnButtonSet() 
{
	Prog_Set();
}

//--------------------------------------------------------------------------------------------------
//	ϊJn																						
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::OnButtonStart() 
{
	Prog_Start();
}

//--------------------------------------------------------------------------------------------------
//	ϊԎ擾																					
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::OnButtonStatus() 
{
	//i[TvO̎擾
	long	AiSamplingCount;
    Ret = AioGetAiSamplingCount(Id, &AiSamplingCount);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioGetAiSamplingCount = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}
	TextString.Format("%d", AiSamplingCount);
	m_Count.SetWindowText(TextString);

	//Xe[^X̎擾
	long	AiStatus;
    Ret = AioGetAiStatus(Id, &AiStatus);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioGetAiStatus = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}
	TextString.Format("%xH", AiStatus);
	m_Status.SetWindowText(TextString);

	m_ErrorString.SetWindowText("Get ADC Status : Nomally end");
}

//--------------------------------------------------------------------------------------------------
//	ϊ~																						
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::OnButtonStop() 
{
	Prog_Stop();
}

//--------------------------------------------------------------------------------------------------
//	foCX̏I																				
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::OnButtonEnd() 
{
	Prog_End();
}
//--------------------------------------------------------------------------------------------------
//  CxgbZ[W[`																		
//--------------------------------------------------------------------------------------------------
LRESULT CAiLongDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	CString sYr, sMn;
	CString sDir;
	CFileStatus rStatus;

	switch(message){
	//wTvO񐔊i[Cxg
		//ADϊ͊O1PPS̗͂オ(orjŊJnA1bɂ̃Cxg荞݂B
		//]āACurTime̎擾̎́Af[^̐擪̎1bxĂ
		//ȂAʓrVB2008ō쐬GPS_TIMEŁA1PPSɂ茈܂鐳b葁^C~O
		//PC̎XV悤ɂĂB
		//̂߁ACurTimeɂ́A̎̎^C~O炸ɐ͂
	case AIOM_AIE_DATA_NUM:

		//WDTZbg
		n_wdt = n_wdt_max;

		//XyNgϕJEg
		n_save_count += 1;

		//擾
		CurTime = CTime::GetCurrentTime();
		CurTime -= CTimeSpan(0, 0, 0, 1);		//f[^̐擪̎擾

		//\
		NowTime = CurTime.Format( "%Y/%m/%d %H:%M:%S" );
		m_ErrorString.SetWindowText(NowTime+" DAQ trigger");

		//ۑpϐ
		short SY,SD,SH, ST;
		SY = CurTime.GetYear();
		SD = CurTime.GetMonth()*100+CurTime.GetDay();
		SH = CurTime.GetHour();
		ST = CurTime.GetMinute()*100+CurTime.GetSecond();

		//wTvO񐔊i[Cxg񐔂̕\
		AiEventCount++;
		TextString.Format("%d\n", AiEventCount);
		m_Event.SetWindowText(TextString);

		//擾TvOf[^i[zTCYȂ悤
		if(lParam * AiChannels > DATA_SMP * n_ch){
			lParam = DATA_SMP * n_ch / AiChannels;
		}

		//ϊf[^擾
		Ret = AioGetAiSamplingDataEx(Id, (long *)&lParam, &AiData[0]);
	    if(Ret != 0){
		    Ret2 = AioGetErrorString(Ret, ErrorString);
			TextString.Format("AioGetAiSamplingDataEx = %d : %s", Ret, ErrorString);
			m_ErrorString.SetWindowText(TextString);
			return TRUE;
		}

		//---------------------------------------------------------------------

		//f[^wb_[Lqpϐ
		short block_size;
		short s_val;
		unsigned char uc_val;
		short s_mark;
		float sf_data[n_ch_max];
		short sfs,efs,s_sf_data;

		//FFT̎s
		int i, j, jj, jjj, n, nn, n_ave, n_ave_p;

		n_ave = DATA_SMP/n_fft;			// number of average for 1sec (spectrum data)
		n_ave_p = DATA_SMP/n_fft/10;	// number of average for 0.1sec (point freq data)

		//o̓f[^pt@CJ
		FILE *stream1, *stream2;

		// Open for write 
		char cSta[4];
		m_STA.GetWindowText(cSta, 4);
		sSta = cSta;
		sDate = CurTime.Format("%Y%m%d%H");

		sYr = CurTime.Format("%Y");
		sMn = CurTime.Format("%m");

		sDir = _T("C:\\LF_DATA\\data\\") + sYr;
		if (!(CFile::GetStatus(sDir, rStatus) ||
			(sDir.GetLength() == 2 && sDir.GetAt(1) == ':')))
			::CreateDirectory(sDir, NULL);
		sDir = _T("C:\\LF_DATA\\data\\") + sYr + _T("\\") + sMn;
		if (!(CFile::GetStatus(sDir, rStatus) ||
			(sDir.GetLength() == 2 && sDir.GetAt(1) == ':')))
			::CreateDirectory(sDir, NULL);

		memset(sf_data, 0x00, sizeof(sf_data));

		for( j = 0; j<n_ch;  j++ ){			// *** ch loop ***

			jjj = j * n_spc_ch;
			sCh.Format( "%02d", j+1 );

			if ( n_ch > 1 ){
				sFile1 = sDir + _T("\\") + sSta + sDate +_T("_") + sCh + _T(".dat");
			}else{
				sFile1 = sDir + _T("\\") + sSta + sDate + _T(".dat");
			}
			if( CFile::GetStatus(sFile1, FileStat) ){
				//t@C̏ꍇAǋL[hŊJ
				fopen_s( &stream1, sFile1, "ab" );
			}else{
				//VKt@C̏ꍇA݃[hŊJăwb_ۑ
				fopen_s( &stream1, sFile1, "wb" );
				fwrite(&SY,sizeof(short),1,stream1);				//(1)N							(2 byte)
				fwrite(&SD,sizeof(short),1,stream1);				//(2)						(2 byte)
				fwrite(&SH,sizeof(short),1,stream1);				//(3)							(2 byte)
				s_val = (short)(DATA_SMP/1000);						//(4)TvOg[kHz]	(2 byte)
				fwrite(&s_val,sizeof(short),1,stream1);	
				s_val = (short)n_fft;								//(5)FFT_					(2 byte)
				fwrite(&s_val,sizeof(short),1,stream1);		
				s_val = (short)n_fq;								//(6)ۑg_				(2 byte)
				fwrite(&s_val,sizeof(short),1,stream1);		
				block_size = (2+(n_fq*2+1)*10)*sizeof(short);
				fwrite(&block_size,sizeof(short),1,stream1);		//(7)f[^ubNTCY[Byte]	(2 byte)
				for( n = 0; n < n_fq; n++ )							//ۑg[kHzx100]			(2 x n_fq byte)
					fq_pw[n] = (short)(fq[n]*100);
				fwrite(&fq_pw,sizeof(short),n_fq,stream1);			//ۑ|Cgg
				fwrite(&cSta,4,1,stream1);							//(8-9)ϑn_				(4 byte)
				sfs = (short)(sf*100);
				efs = (short)(ef*100);
				fwrite(&sfs,sizeof(short),1,stream1);				//(10)Sfericsj^Jng	(2 byte)
				fwrite(&efs,sizeof(short),1,stream1);				//(11)Sfericsj^Ig	(2 byte)
				s_val = (short)n_wdt_hist;							//(12)WDTZbg			(2 byte)
				fwrite(&s_val,sizeof(short),1,stream1);
				uc_val = (unsigned char)(j+1);						//(13)Ch					(1 byte x 2)
				fwrite(&uc_val,sizeof(unsigned char),1,stream1);
				uc_val = (unsigned char)n_ch;
				fwrite(&uc_val,sizeof(unsigned char),1,stream1);
				uc_val = (unsigned char)m_FFT_WND.GetCurSel();		// FFT window (1 byte)
				fwrite(&uc_val,sizeof(unsigned char),1,stream1);
				block_size = block_size - ( n_fq*2 + 29 );	//cubNTCY/sizeof(short)
				uc_val=0;
				for( n = 0; n < block_size; n++ )
					fwrite(&uc_val,sizeof(unsigned char),1,stream1);			//c0Ŗ߂
				uc_val = (unsigned char)sw_ver;						// SW verstion number (1 byte)
				fwrite(&uc_val,sizeof(unsigned char),1,stream1);
				uc_val = (unsigned char)sw_subver;					// SW sub-verstion number (1 byte)
				fwrite(&uc_val,sizeof(unsigned char),1,stream1);
			}

			// *** ubN擪}[J[Ǝ̏ ***
			s_mark = 32767;
			fwrite(&s_mark,sizeof(short),1,stream1);				//擪}[J[				(2 byte)
			fwrite(&ST,sizeof(short),1,stream1);					//iMMSS)
		
			// *** FFT̎{уATu ***
			// zero-reset variables
			memset(ave_pow_p, 0x00, sizeof(ave_pow_p));
			memset(ave_sin_p, 0x00, sizeof(ave_sin_p));
			memset(ave_cos_p, 0x00, sizeof(ave_cos_p));

			for( i = 0; i<n_ave; i++ ){			// *** 1-sec loop ***

				// copy input data		
				for( n = 0; n < n_fft; n++ ){
					//f[^I֐Kp
					jj = j + i*n_ch*n_fft;
					v_fft1[n] = AiData[ n*n_ch + jj ] * w_fft[n];
					v_fft2[n] = 0.0;
				}
				// forward FFT (get power and phase spectra)
				FFT_excute(n_fft, &v_fft1[0],&v_fft2[0]);

				if ( ((i+1) % n_ave_p) == 0){	// *** every 0.1sec ***
					//|Cggf[^ۑ
					for( n = 0; n < n_fq; n++ ){
						fq_pw[n] = (short)(10.0*log10(ave_pow_p[n]/(float)n_ave_p)*100.0);				//[dB]x100
						fq_ph[n] = (short)(atan2(ave_sin_p[n],ave_cos_p[n])*1000.0);	//[radian]x1000
					}
					fwrite(&fq_pw,sizeof(short),n_fq,stream1);			//|Cggf[^̕ۑ(U)
					fwrite(&fq_ph,sizeof(short),n_fq,stream1);			//|Cggf[^̕ۑ(ʑ)

					//Sfericsf[^̕ۑ
					s_sf_data = (short)(10.0*log10(sf_data[j]/float(ief-isf+1)/(float)n_ave_p)*100.0);	//[dB]x100
					fwrite(&s_sf_data, sizeof(short),1,stream1);		//sfericsf[^̕ۑ
					// show the value on the dialog
					TextString.Format("%.2f", sf_data[j]);
					m_EDIT_SFM.SetWindowText(TextString);

					// zero-reset variables
					memset(ave_pow_p, 0x00, sizeof(ave_pow_p));
					memset(ave_sin_p, 0x00, sizeof(ave_sin_p));
					memset(ave_cos_p, 0x00, sizeof(ave_cos_p));
					sf_data[j] = 0.0;

				}
				//|Cggf[^̃ATu
				for( n = 0; n < n_fq; n++ ){
					float pow0 = 0.0;
					float sin0 = 0.0;
					float cos0 = 0.0;
					for (nn = -ifw[n]; nn < ifw[n]+1; nn++)
					{
						pow0 += v_fft1[ifq[n + nn]];
						sin0 += sin(v_fft2[ifq[n + nn]]) * v_fft1[ifq[n + nn]];
						cos0 += cos(v_fft2[ifq[n + nn]]) * v_fft1[ifq[n + nn]];
					}
					ave_pow_p[n] += pow0;
					ave_sin_p[n] += sin0/pow0;
					ave_cos_p[n] += cos0/pow0;
//					ave_pow_p[n] += v_fft1[ifq[n]];
//					ave_sin_p[n] += sin(v_fft2[ifq[n]]);
//					ave_cos_p[n] += cos(v_fft2[ifq[n]]);
				}
				//Sfericsf[^̐ώZ
				for( n = isf; n < ief; n++ ){
					sf_data[j] += v_fft1[n];
				}
#ifdef d_SPC
				//XyNgf[^̃ATu
				ave_pow[0 + jjj] += v_fft1[0];
				ave_sin[0 + jjj] += sin(v_fft2[0]);
				ave_cos[0 + jjj] += cos(v_fft2[0]);
				for( n = 1; n < n_fft/2+1; n++ ){
					nn = (int)((n-1)/n_save_f);
					ave_pow[nn + jjj] += v_fft1[n];
					ave_sin[nn + jjj] += sin(v_fft2[n]);
					ave_cos[nn + jjj] += cos(v_fft2[n]);
				}
#endif
			}				// end of 1-sec loop

			fclose(stream1);

			if ( j == m_ch_disp.GetCurSel() ){
				//|Cggf[^̕\(l)
				float pd;
				for (n = 0; n < n_fq; n++ ){
					pd = (float)(fq_pw[n]/100.0) + pow_ref ;			//[dBVpp]
					TextString.Format("%.2f",pd);
					m_Edit_pw[n].SetWindowText(TextString);
					pd = (float)(fq_ph[n]/1000.0);						//[radian]
					TextString.Format("%.2f", pd);						
					m_Edit_ph[n].SetWindowText(TextString);
				}

				//Sfericsf[^̕\(`)
				Draw_LM( sf_data[j] );
			}

			//|Cggf[^̕\(`)
			int Index;
			Index = m_Freq_List.GetCurSel();
			Draw_QL(v_fft2[ifq[Index]], j);


#ifdef d_SPC
			// *** σXyNg̕ۑ ***
			if (n_save_count == n_save_t){

				for (n = 0; n < n_spc_ch; n++ ){
					ave_pow[n+jjj]	= (float)(10.0*log10(ave_pow[n+jjj]/(float)n_ave));	//[dB]
					pow_save[n]		= (short)(ave_pow[n+jjj]*100.0);					//[dB]x100
					ave_cos[n+jjj]	= atan2(ave_sin[n+jjj],ave_cos[n+jjj]);					//[radian]
					pha_save[n]		= (short)(ave_cos[n+jjj]*1000.0);					//[radian]x1000
				}

				//ۑpf[^t@C
				if ( n_ch > 1 ){
					sFile2 = sDir + _T("\\") + sSta + sDate +_T("_") + sCh + _T(".spc");
				}else{
					sFile2 = sDir + _T("\\") + sSta + sDate + _T(".spc");
				}
			
				if( CFile::GetStatus(sFile2, FileStat) ){
					//t@C̏ꍇAǋL[hŊJ
					fopen_s( &stream2, sFile2, "ab" );
				}else{
					//VKt@C̏ꍇA݃[hŊJăwb_ۑ
					fopen_s( &stream2, sFile2, "wb" );
					fwrite(&SY,sizeof(short),1,stream2);		//(1)N						(2 byte)
					fwrite(&SD,sizeof(short),1,stream2);		//(2)					(2 byte)
					fwrite(&SH,sizeof(short),1,stream2);		//(3)					(2 byte)
					s_val = (short)(DATA_SMP/1000);			
					fwrite(&s_val,sizeof(short),1,stream2);		//(4)TvOg[kHz](2 byte)
					s_val = (short)n_fft;						//(5)FFT_				(2 byte)
					fwrite(&s_val,sizeof(short),1,stream2);		
					s_val = (short)n_save_t;					//(6)ԕ(b)		(2 byte)
					fwrite(&s_val,sizeof(short),1,stream2);		
					s_val = (short)n_save_f;					//(7)g(_)		(2 byte)
					fwrite(&s_val,sizeof(short),1,stream2);		
					s_val = (short)(n_fft/n_save_f/2+1);		//(8)g_			(2 byte)
					fwrite(&s_val,sizeof(short),1,stream2);		
					s_val = (short)(DATA_SMP/n_fft*n_save_f);	//(9)g\(Hz)		(2 byte)
					fwrite(&s_val,sizeof(short),1,stream2);		
					block_size = (short)((n_fft/n_save_f/2+1)*2+2)*sizeof(short);
																//(10)ubNTCY[Byte]	(2 byte)
					fwrite(&block_size,sizeof(short),1,stream2);		
					fwrite(&cSta,4,1,stream2);					//(11-12)ϑn_			(4 byte)
					s_val = (short)n_wdt_hist;					//(13)WDTZbg		(2 byte)
					fwrite(&s_val,sizeof(short),1,stream1);		
					uc_val = (unsigned char)(j+1);				//(14)Ch				(1 byte x 2)
					fwrite(&uc_val,sizeof(unsigned char),1,stream1);
					uc_val = (unsigned char)n_ch;
					fwrite(&uc_val,sizeof(unsigned char),1,stream1);
					uc_val = (unsigned char)m_FFT_WND.GetCurSel();		// FFT window		(1 byte)
					fwrite(&uc_val,sizeof(unsigned char),1,stream1);
					block_size = block_size - 31;			//cubNTCY
					uc_val=0;
					for( n = 0; n < block_size; n++ )		//c0Ŗ߂
						fwrite(&uc_val,sizeof(unsigned char),1,stream2);	
					uc_val = (unsigned char)sw_ver;						// SW verstion number (1 byte)
					fwrite(&uc_val,sizeof(unsigned char),1,stream1);
					uc_val = (unsigned char)sw_subver;					// SW sub-verstion number (1 byte)
					fwrite(&uc_val,sizeof(unsigned char),1,stream1);
				}

				fwrite(&s_mark,sizeof(short),1,stream1);					//擪}[J[			(2 byte)
				fwrite(&ST,sizeof(short),1,stream2);						//(HHMMSS)			(2 byte)
				fwrite(pow_save,sizeof(short),n_fft/n_save_f/2+1,stream2);	//σXyNgf[^̕ۑ(U)
				fwrite(pha_save,sizeof(short),n_fft/n_save_f/2+1,stream2);	//σXyNgf[^̕ۑ(ʑ)

				fclose(stream2);

				//Convert power unit for display
				for (n = 0; n < n_spc_ch; n++ ){
					ave_pow[n + jjj]	+= pow_ref;		// dBc -> dBVpp
				}
				Draw_SP(&ave_frq[0],&ave_pow[0],&ave_cos[0],&fq[0],j);

				// ϐď
				for( n = 0; n < n_spc_ch; n++ ){ 
					ave_pow[n + jjj] = 0.0;
					ave_sin[n + jjj] = 0.0;
					ave_cos[n + jjj] = 0.0;
				}
			}
#endif
		}					// end of ch loop

		if (n_save_count == n_save_t) n_save_count = 0;

		//---------------------------------------------------------------------

		//擾TvO񐔂̕\
		AiTotalSamplingTimes += (long)lParam;
		TextString.Format("%d\n", AiTotalSamplingTimes);
		m_Total.SetWindowText(TextString);

		//TvO̎擾
		long	AiSamplingCount;
	    Ret = AioGetAiSamplingCount(Id, &AiSamplingCount);
	    if(Ret != 0){
		    Ret2 = AioGetErrorString(Ret, ErrorString);
			TextString.Format("AioGetAiSamplingCount = %d : %s", Ret, ErrorString);
			m_ErrorString.SetWindowText(TextString);
			return TRUE;
		}
		TextString.Format("%d", AiSamplingCount);
		m_Count.SetWindowText(TextString);

		//Xe[^X̎擾
		long	AiStatus;
	    Ret = AioGetAiStatus(Id, &AiStatus);
	    if(Ret != 0){
		    Ret2 = AioGetErrorString(Ret, ErrorString);
			TextString.Format("AioGetAiStatus = %d : %s", Ret, ErrorString);
			m_ErrorString.SetWindowText(TextString);
			return TRUE;
		}
		TextString.Format("%xH", AiStatus);
		m_Status.SetWindowText(TextString);

		//\
		m_ErrorString.SetWindowText(NowTime+" End...");

		return TRUE;

	//I[o[t[Cxg
	case AIOM_AIE_OFERR:
		//擾
		CurTime = CTime::GetCurrentTime();
		CurTime -= CTimeSpan(0, 0, 0, 1);		//f[^̐擪̎擾
		//\
		NowTime = CurTime.Format( "%Y/%m/%d %H:%M:%S" );
		m_ErrorString.SetWindowText(NowTime+"ADC Stop due to overflow error");

		// add at Nov.22 2010
		Prog_Error("ADC Stop due to overflow error", NowTime);

		return TRUE;

	//TvONbNG[Cxg
	case AIOM_AIE_SCERR:
		//擾
		CurTime = CTime::GetCurrentTime();
		CurTime -= CTimeSpan(0, 0, 0, 1);		//f[^̐擪̎擾
		//\
		NowTime = CurTime.Format( "%Y/%m/%d %H:%M:%S" );
		m_ErrorString.SetWindowText(NowTime+"ADC Stop due to sampling clock error");

		// add at Nov.22 2010
		Prog_Error("ADC Stop due to sampling clock error", NowTime);

		return TRUE;

	//ADϊG[Cxg
	case AIOM_AIE_ADERR:
		//擾
		CurTime = CTime::GetCurrentTime();
		CurTime -= CTimeSpan(0, 0, 0, 1);		//f[^̐擪̎擾
		//\
		NowTime = CurTime.Format( "%Y/%m/%d %H:%M:%S" );
		m_ErrorString.SetWindowText(NowTime+"ADC Stop due to ADC error");

		// add at Nov.22 2010
		Prog_Error("ADC Stop due to ADC error", NowTime);

		return TRUE;

	//ϊICxg
	case AIOM_AIE_END:

		//擾
		CurTime = CTime::GetCurrentTime();
		CurTime -= CTimeSpan(0, 0, 0, 1);		//f[^̐擪̎擾
		//\
		NowTime = CurTime.Format( "%Y/%m/%d %H:%M:%S" );
		m_ErrorString.SetWindowText(NowTime+"ADC Stop by AIOM_AIE_END");

		// add at Oct.26 2010 (temporally)
		Prog_Error("ADC Stop by AIOM_AIE_END", NowTime);

		return TRUE;
	}
	return CDialog::DefWindowProc(message, wParam, lParam);
}

//--------------------------------------------------------------------------------------------------
//	FFT֐
//	͎Fv_fft1,v_fft2Fn(Re & Img)
//	o͎Fv_fft1,v_fft2FUшʑXyNg
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::FFT_excute(long n_fft, float *v_fft1, float *v_fft2)
{
  fftw_complex *in, *out;
  fftw_plan p;
  int n;

  /* allocate memory */
  in  = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * n_fft);
  out = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * n_fft);

  /* copy data to fftw buffer (in) */
  for( n = 0; n < n_fft; n++ ) {
    in[n][0] = v_fft1[n];
    in[n][1] = v_fft2[n];
  }

  /* create plan */
  p = fftw_plan_dft_1d(n_fft, in, out, FFTW_FORWARD, FFTW_ESTIMATE);

  /* do FFT */
  fftw_execute(p);

  /* copy data to fftw buffer (out) */
  for( n = 0; n < n_fft; n++ ){
	v_fft1[n] = (float)(pow(out[n][0],2)+pow(out[n][1],2));
	v_fft2[n] = (float)atan2(out[n][1],out[n][0]);
  }

  /* free memories */
  fftw_destroy_plan(p);
  fftw_free(in);
  fftw_free(out);

}

//--------------------------------------------------------------------------------------------------
//	ۑgǂݍ	(devie.txt)
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::Read_Dev(void)
{
	int n = 0;

	// Open for read 
	std::ifstream ifs("C:\\LF_DATA\\device.txt");
	std::string str;

	// Read ADC devce name (defined by device Windows manager)
	getline(ifs, str);
	CString s1(str.c_str());
	m_Device.SetWindowText(s1);

	//Station name
	getline(ifs, str);
	CString s2(str.c_str());
	m_STA.SetWindowText(s2);

}

//--------------------------------------------------------------------------------------------------
//	ۑgǂݍ	(fq_list.txt)
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::Read_Fq(float* fq, int* ifw)
{
		int n = 0;
		float fq_tmp[n_fq_max+2];
		int   ifw_tmp[n_fq_max + 2];
		float fq0;
		int   ifw0;

		// Open for read 
		std::ifstream ifs("C:\\LF_DATA\\fq_list.txt");
		std::string str;
		std::stringstream ss;

		// Read frequencies to be saved
		while (getline(ifs, str)) {
			std::stringstream ss(str);
			ss >> fq0 >> ifw0;
//			std::cout << "#" << str << std::endl;
//			fq_tmp[n] = std::stof(str);
			fq_tmp[n] = fq0;
			ifw_tmp[n] = ifw0;
			n ++;
		}

		n_fq = n-2;
		for( n = 0; n < n_fq; n++ ){
			fq[n] = fq_tmp[n];
			ifw[n] = ifw_tmp[n];
			// show frequency values on the dialog
			TextString.Format("%.2f", fq[n]);
			m_Edit_fq[n].SetWindowText(TextString);
			m_Freq_List.AddString(TextString);
		}
		m_Freq_List.SetCurSel(0);

		// Read Sferics monitor frequency range
		sf = fq_tmp[n_fq];
		// show frequency values on the dialog
		TextString.Format("%.2f", sf);
		m_EDIT_SF.SetWindowText(TextString);
		// Read Sferics monitor frequency range
		ef = fq_tmp[n_fq+1];
		// show frequency values on the dialog
		TextString.Format("%.2f", ef);
		m_EDIT_EF.SetWindowText(TextString);
}

//--------------------------------------------------------------------------------------------------
//	XyNg̕`
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::Draw_SP(float *x, float *ya, float *yp, float *fq, int i_ch)
{
	int n;
	int x1,x2,ya1,ya2;
	float xmax,xmin,yamax,yamin,ypmax,ypmin;

	m_EDIT_X1.GetWindowText(TextString);
	xmax = (float)atof(TextString);
	m_EDIT_X2.GetWindowText(TextString);
	xmin = (float)atof(TextString);
/*
	xmax = 0.0;
	xmin = 100.0;
*/
	yamax = 30.0;
	yamin = -120.0;
	ypmin = (float)Pi;
	ypmax = (float)(-Pi);

	//Fw
	int i_col;
	switch (i_ch){
		case 0:
			i_col = RGB(255,0,0);
			break;
		case 1:
			i_col = RGB(0,0,255);
			break;
	}

	//`̐ݒ
	CClientDC SP_PictDC(&m_PICT_SP);
	CRect SP_Rect;
	m_PICT_SP.GetClientRect(SP_Rect);

	if (i_ch == 0){
		//`̃NA
		SP_PictDC.FillSolidRect(SP_Rect,RGB(255,255,255));

		//ۑgʒu̕`
		for( n = 0; n < n_fq; n++ ){
			x1 = (int)(SP_Rect.right-(fq[n]-xmin)/(xmax-xmin)*SP_Rect.right);
			x2 = x1;
			ya1 = (int)(SP_Rect.bottom);
			ya2 = (int)(SP_Rect.bottom-SP_Rect.bottom*0.05);
			SP_PictDC.MoveTo(x1,ya1);
			SP_PictDC.LineTo(x2,ya2);
		}
	}
	//XyNg̕`
	for( n = 0; n < n_fft/n_save_f/2; n++ ){
		//U
		x1 = (int)(SP_Rect.right-(x[n]-xmin)/(xmax-xmin)*SP_Rect.right);
		x2 = (int)(SP_Rect.right-(x[n+1]-xmin)/(xmax-xmin)*SP_Rect.right);
		ya1 = (int)(SP_Rect.bottom-(ya[n]-yamin)/(yamax-yamin)*SP_Rect.bottom);
		ya2 = (int)(SP_Rect.bottom-(ya[n+1]-yamin)/(yamax-yamin)*SP_Rect.bottom);
		SP_PictDC.SetDCPenColor(i_col);
		SP_PictDC.MoveTo(x1,ya1);
		SP_PictDC.LineTo(x2,ya2);
/*
		//ʑ
		yp2 = (int)(SP_Rect.bottom-(yp[n+1]-ypmin)/(ypmax-ypmin)*SP_Rect.bottom);
		SP_PictDC.SetPixel(x2,yp2,RGB(255,0,0));
*/
	}
	SP_PictDC.SetDCPenColor(RGB(0,0,0));
}

//--------------------------------------------------------------------------------------------------
//	ʑQL̕`
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::Draw_QL(float phase, int i_ch)
{

	int x,y;
	float xmax,xmin,ymax,ymin;

	xmax = 0.0;
	xmin = 3600.0;
	ymax = (float)Pi;
	ymin = (float)(-Pi);

	//Fw
	int i_col;
	switch (i_ch){
		case 0:
			i_col = RGB(255,0,0);
			break;
		case 1:
			i_col = RGB(0,0,255);
			break;
	}

	//擾
	CTime PlotTime;
	short PlotSec;
	PlotTime = CTime::GetCurrentTime();
	PlotSec = PlotTime.GetSecond()+PlotTime.GetMinute()*60;	//Total second

	//`̐ݒ
	CClientDC QL_PictDC(&m_PICT_QL);
	CRect QL_Rect;
	m_PICT_QL.GetClientRect(QL_Rect);

	//`̃NA(00:00)
	if (PlotSec==0){
		QL_PictDC.FillSolidRect(QL_Rect,RGB(255,255,255));
	}

	//`
	x = (int)(QL_Rect.right-(PlotSec-xmin)/(xmax-xmin)*QL_Rect.right);
	y = (int)(QL_Rect.bottom-(phase-ymin)/(ymax-ymin)*QL_Rect.bottom);
	QL_PictDC.SetPixel(x,y,i_col);

}


//--------------------------------------------------------------------------------------------------
// Sferics̕`(Lightning Monitor)
//--------------------------------------------------------------------------------------------------
void CAiLongDlg::Draw_LM(float sferics)
{

	int x,y;
	float xmax,xmin,ymax,ymin;

	xmax = 0.0;
	xmin = 3600.0;
	ymax = 10.0;
	ymin = 0.0;

	//擾
	CTime PlotTime;
	short PlotSec;
	PlotTime = CTime::GetCurrentTime();
	PlotSec = PlotTime.GetSecond()+PlotTime.GetMinute()*60;	//Total second

	//`̐ݒ
	CClientDC LM_PictDC(&m_IDC_PICT_LM);
	CRect LM_Rect;
	m_IDC_PICT_LM.GetClientRect(LM_Rect);

	//`̃NA(00:00)
	if (PlotSec==0) LM_PictDC.FillSolidRect(LM_Rect,RGB(255,255,255));

	//`
	x = (int)(LM_Rect.right-(PlotSec-xmin)/(xmax-xmin)*LM_Rect.right);
	y = (int)(LM_Rect.bottom-(sferics-ymin)/(ymax-ymin)*LM_Rect.bottom);
	LM_PictDC.SetPixel(x,y,RGB(255,0,0));

}


void CAiLongDlg::Prog_Init()
{
	//
	char	DeviceName[100];
	m_Device.GetWindowText(DeviceName, 100);
	Ret = AioInit(DeviceName, &Id);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioInit = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//foCX̃Zbg
	Ret = AioResetDevice(Id);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioResetDevice = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//G[JEg̃Zbg
	n_error = 0;

	//ZV[YɂāAoX}X^pobt@ő1MByteȉɐl750KByteɐ܂B
	//VXeł́AKvɉĎĂB
	Ret = AioSetAiMemorySize(Id, 750 * 1024);

	m_ErrorString.SetWindowText("ADC Initialize : Nomally end");
}

void CAiLongDlg::Prog_Range()
{
	short	AiRange;
	short	Index;
	Index = m_AiRange.GetCurSel();
	switch(Index){
		case 0:	AiRange = PM10;		break;
		case 1:	AiRange = PM5;		break;
	}

	m_ErrorString.SetWindowText("Change ADC input range  : Nomally end");
}

void CAiLongDlg::Prog_Set()
{
	short	Index;
	int		n;

	m_Count.SetWindowText("0");
	m_Event.SetWindowText("0");
	m_Total.SetWindowText("0");
	AiEventCount = 0;
	AiTotalSamplingTimes = 0;

	//foCXobt@gp̐ݒ(0)
	//Ret = AioSetAiTransferMode ( Id , 1 );

	//̓W̐ݒ
	short	AiRange;
	Index = m_AiRange.GetCurSel();
	switch(Index){
		case 0:	AiRange = PM10;		break;
		case 1:	AiRange = PM5;		break;
	}
	Ret = AioSetAiRangeAll(Id, AiRange);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioSetAiRangeAll = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//`l̐ݒ
	AiChannels = m_ch.GetCurSel() + 1;
	n_ch = AiChannels;
	Ret = AioSetAiChannels(Id, AiChannels);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioSetAiChannels = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//`̐ݒFFIFO
	Ret = AioSetAiMemoryType(Id, 0);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioSetAiMemoryType = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//NbNނ̐ݒFO(1) or (0)
	Ret = AioSetAiClockType(Id, 1);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioSetAiClockType = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//ϊx̐ݒF5usec(Œ)
	float Samp_Time;
	Samp_Time = 1000000/DATA_SMP;
	Ret = AioSetAiSamplingClock(Id, Samp_Time);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioSetAiSamplingClock = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//Jn̐ݒFOX^[ggK(1PPS)
	Ret = AioSetAiStartTrigger(Id, 0);	// 0:S/W 1:オ@2:(default)
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioSetAiStartTrigger = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//~̐ݒFR}h
	Ret = AioSetAiStopTrigger(Id, 4);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioSetAiStopTrigger = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//Cxgv̐ݒFfoCXIAwTvO񐔊i[A
	//					@I[o[t[ANbNG[AADϊG[
	long	AiEvent;
	AiEvent = AIE_END | AIE_DATA_NUM | AIE_OFERR | AIE_SCERR | AIE_ADERR;
	Ret = AioSetAiEvent(Id, m_hWnd, AiEvent);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioSetAiEvent = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//wTvO񐔊i[Cxg̃TvO̐ݒF200,000 = every 1sec
	Ret = AioSetAiEventSamplingTimes( Id, DATA_SMP );
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioSetAiEventSamplingTimes = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

//FFT̐ݒ

	//FFT_̓ǂݍ
	m_FFT_Num.GetWindowText(TextString);
	n_fft = (long)atof(TextString);

	//WINDOW֐̐ݒ
	Index = m_FFT_WND.GetCurSel();
	switch(Index){
		case 0:		// Blckman window
			for( n = 0; n < n_fft; n++ ) 
				w_fft[n] = (float)(0.42-0.5*cos(2*Pi*(float)n/(float)(n_fft-1))+0.08*cos(4*Pi*(float)n/(float)(n_fft-1)));
			break;
		case 1:		// Hamming
			for( n = 0; n < n_fft; n++ ) 
				w_fft[n] = (float)(0.54-0.46*cos(2*Pi*(float)n/(float)(n_fft-1)));
			break;
		case 2:		// Hanning
			for( n = 0; n < n_fft; n++ ) 
				w_fft[n] = (float)(0.5-0.5*cos(2*Pi*(float)n/(float)(n_fft-1)));
			break;
		case 3:		// Flat top
			for( n = 0; n < n_fft; n++ ) 
				w_fft[n] = 1.0;
			break;
	}

	//gz̐ݒ
	float delta_freq;

	delta_freq = (float)(DATA_SMP/1000.0)/(float)n_fft;		//[kHz]
	for( n = 0; n < n_fft/2+1; n++ )
		f_fft[n] = delta_freq*(float)n;						//[kHz]

	delta_freq = delta_freq*(float)n_save_f;				//[kHz]
	for( n = 0; n < n_fft/n_save_f/2+1; n++ )
		ave_frq[n] = delta_freq*(float)n;					//[kHz]

	//ۑgXg̓ǂݍ
	Read_Fq(fq, ifw);

	delta_freq = (float)DATA_SMP/(float)n_fft/(float)1000.0;		//[kHz]
	for( n = 0; n < n_fq; n++ )
		ifq[n] = (long)(fq[n]/delta_freq);
	isf = (long)(sf/delta_freq);
	ief = (long)(ef/delta_freq);

	m_ErrorString.SetWindowText("ADC Settings : Nomally end");

}

void CAiLongDlg::Prog_Start()
{
	int n;

	// ϐ
	for( n = 0; n < n_fft/n_save_f/2+1; n++ ){ 
		ave_pow[n] = 0.0;
		ave_sin[n] = 0.0;
		ave_cos[n] = 0.0;
	}
	n_save_count = 0;

	//̃Zbg
	Ret = AioResetAiMemory(Id);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioResetAiMemory = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

/*	//ϊJnҋ@
	CTime WaitTime;

	WaitTime = CTime::GetCurrentTime();
	while (WaitTime.GetSecond() != 0){
		WaitTime = CTime::GetCurrentTime();
		TextString=WaitTime.Format( "%Y/%m/%d@%H:%M:%S" );
		m_ErrorString.SetWindowText("ϊJnҋ@ "+TextString);
	}
*/

	//ϊJn
    Ret = AioStartAi(Id);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioStartAi = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//擾
	CurTime = CTime::GetCurrentTime();
	//\
	NowTime = CurTime.Format( "%Y/%m/%d %H:%M:%S" );

	// output log
	Prog_Save_Error("Press start (Prog_Start)", NowTime);

	m_ErrorString.SetWindowText("Start ADCFNomally end");
}

void CAiLongDlg::Prog_Stop()
{

	//ϊ~
    Ret = AioStopAi(Id);
    if(Ret != 0){
	    Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioStopAi = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//擾
	CurTime = CTime::GetCurrentTime();
	//\
	NowTime = CurTime.Format( "%Y/%m/%d %H:%M:%S" );

	// output log
	Prog_Save_Error("Press stop (Prog_Stop)", NowTime);

	// WDT pause
	n_wdt = 0;

	m_ErrorString.SetWindowText("Stop ADC : Nomally end");
}

void CAiLongDlg::Prog_End()
{

	//AD쒆̏ꍇ́AAD~
	//Xe[^X̎擾
	long	AiStatus;
    Ret = AioGetAiStatus(Id, &AiStatus);
    if(Ret == 0 && AiStatus == AIS_BUSY){
		Ret = AioStopAi(Id);
	}

	//foCX̏I
	Ret = AioExit(Id);
    if(Ret != 0){
		Ret2 = AioGetErrorString(Ret, ErrorString);
		TextString.Format("AioExit = %d : %s", Ret, ErrorString);
		m_ErrorString.SetWindowText(TextString);
		return;
	}

	//擾
	CurTime = CTime::GetCurrentTime();
	//\
	NowTime = CurTime.Format( "%Y/%m/%d %H:%M:%S" );

	// Output log
	Prog_Save_Error("Press end (Prog_End)", NowTime);

	// WDT pause
	n_wdt = 0;

	m_ErrorString.SetWindowText("ADC Close : Nomally end");
}


void CAiLongDlg::Prog_Error(CString Str_error, CString Str_time)
{
/*
	// error counter
	n_error += 1;

	// record error
	Prog_Save_Error(Str_error, Str_time);

	if(n_error >= n_error_max){

		Prog_Save_Error("--- Auto recover strt", Str_time);

		Prog_Stop();
		Prog_End();

		Prog_Init();
		Prog_Range();
		Prog_Set();
		Prog_Start();

		Prog_Save_Error("--- Auto recover end", Str_time);

	}else{
			
		//̃Zbg
		Prog_Save_Error("--- memory reset in Prog_Error", Str_time);
		Ret = AioResetAiMemory(Id);
		if(Ret != 0){
			Ret2 = AioGetErrorString(Ret, ErrorString);
			TextString.Format("AioResetAiMemory = %d : %s", Ret, ErrorString);	
		m_ErrorString.SetWindowText(TextString);
		}

		//ϊJn
		Prog_Save_Error("--- Aio start in Prog_Error", Str_time);
		Ret = AioStartAi(Id);
		if(Ret != 0){
			Ret2 = AioGetErrorString(Ret, ErrorString);
			TextString.Format("AioStartAi = %d : %s", Ret, ErrorString);
			m_ErrorString.SetWindowText(TextString);
		}

	}
*/
}


void CAiLongDlg::Prog_Save_Error(CString Str_error, CString Str_time)
{
	FILE *stream4;
	// record error
	fopen_s( &stream4, "C:\\LF_DATA\\error_ad_stop.txt", "a" );
	// date/time
	fprintf_s(stream4, "%s %s (err cnt=%d)\n", Str_time, Str_error, n_error);
	fclose(stream4);

}


// ^C}[bZ[WĂ΂ꂽƂ̏(2016-08-03)
void CAiLongDlg::OnTimer(UINT nIDEvent) 
{
    if (nIDEvent == 1) {

		//擾
		CurTime = CTime::GetCurrentTime();
		//\
		NowTime = CurTime.Format( "%Y/%m/%d %H:%M:%S" );

		if ( n_wdt > 0 ){
			n_wdt --;

			// WDT counter (temporal)
			TextString.Format("total : %d    current cntr : %d", n_wdt_hist, n_wdt);						
			m_wdt.SetWindowTextA(TextString);

			if ( n_wdt == 0 ) {
				
				n_wdt_hist ++;

				Beep(560,200);
				Prog_End();

				Sleep(1000);

				Beep(560,1000);
				Prog_Init();
				Prog_Range();
				Prog_Set();
				Prog_Start();

				// Output log
				Prog_Save_Error("WDT reset at ", NowTime);
			}
		}else{
			TextString.Format("total : %d    current cntr : pause", n_wdt_hist);						
			m_wdt.SetWindowTextA(TextString);
		}
    }

    CDialog::OnTimer(nIDEvent);
}

void CAiLongDlg::OnCancel() 
{
	KillTimer(m_n_wdt);
    CDialog::OnCancel();
}

